
-- return the window size
getWindowSize = getWindowSize or function()
	return 510, 220
end

-- create and lay out all the controls
createUI = createUI or function()

	createUICommon()
	setBannerContent( "nameOnly", 20, 200 )

	-- constants
	local kKnobSpace = 69

	local function knobGroup( LR, title )
		g = group( title )
		
		x = 0
		y = 0
		
		g:add( paramButton( "Enable " .. LR,					"Enable",			x, y, 45, 30 ) )
		x = x + 45 + kKnobSpace

		labelledDropDown( g, "Input Polarity " .. LR,			"Input",			x, y )
		x = x + kDropdownW + kKnobSpace

		smallKnobAndTextField( g, "Min Output Level " .. LR,	"Min Out",			x, y )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Max Output Level " .. LR,	"Max Out",			x, y )
		x = x + kKnobSpace
		
		return g
	end

	-- make groups and knobs
	--

	theKnobRenderer = smallKnobRenderer

	miscGroup = group( "OSC" )
	smallKnobAndTextField( miscGroup, "OSC Port Offset",	"Port",		0*kKnobSpace, 0 )
	miscGroup:setVisible( false )

	leftGroup = knobGroup( "L", "Left Channel" )
	rightGroup = knobGroup( "R", "Right Channel" )
	
	-- positions!

	local pad = 10

	local xbase = 20
	local ybase = 30
	local x = xbase
	local y = ybase
	
	rightGroup:setPosition( x, y )
	x = x + rightGroup:width() + kKnobSpace - kKnobSize
	
	miscGroup:setPosition( x, y )
	x = x + miscGroup:width() + pad
	
	x = xbase
	y = y + rightGroup:height() + pad
	
	leftGroup:setPosition( x, y )
	x = x + leftGroup:width() + pad
	
	-- add directly positioned objects
	--

end		-- of createUI()
